using System;
using Styx;
using Styx.Common;
using Styx.Common.Helpers;
using Styx.CommonBot;
using Styx.CommonBot.Coroutines;
using Styx.CommonBot.Frames;
using Styx.CommonBot.POI;
using Styx.Helpers;
using Styx.Pathing;
using Styx.Plugins;
using Styx.TreeSharp;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;
using Action = Styx.TreeSharp.Action;

namespace Styx
{
	public class MokJump : HBPlugin
	{
		public override string Name { get { return "Mok'gol Jumper"; } }
		public override string Author { get { return "seniorcitizen"; } }
		public override Version Version { get { return _version; } }
		private readonly Version _version = new Version(1, 0, 0, 0);
		
		public readonly WoWPoint _Pivot2 = new WoWPoint(3631.29, 6738.38, 50.69);
		public readonly WoWPoint _Pivot1 = new WoWPoint(3499.97, 6753.46, 43.46);
		public readonly WoWPoint _JumpLoc3 = new WoWPoint(3497.807, 6754.36, 41.98165);
		public readonly WoWPoint _JumpLoc1 = new WoWPoint(3629.286, 6738.38, 50.42);
		public readonly WoWPoint _JumpLoc2 = new WoWPoint(3613.502, 6893.736, 57.46866);
		public override void Pulse()  // check to make adjustments for help jumping into balconies
		{		
			var me = StyxWoW.Me;
			var myLoc = me.Location;   
			if ((myLoc.Z > 63) || (myLoc.Distance2DSqr(_Pivot1) < 1))
				DoSpin();
			if ((myLoc.Distance2DSqr(_Pivot2) < 30) && (myLoc.Z > 50.05))
				DoSpin();
			if ((myLoc.Distance2DSqr(_JumpLoc2) < 1) || (myLoc.Distance2DSqr(_JumpLoc1) < 1) || (myLoc.Distance2DSqr(_JumpLoc3) < 1))
			{
				Logging.Write("Jump!");
				WoWMovement.Move(WoWMovement.MovementDirection.JumpAscend, TimeSpan.FromMilliseconds(500));		
			}
		}
		private static void DoSpin() 
		{
		//	if (StyxWoW.Me.IsFalling)   ** falling behavior to be added
		//		return;
			Logging.Write("Spinning Around...");
			WoWMovement.Move(WoWMovement.MovementDirection.TurnLeft, TimeSpan.FromMilliseconds(800));
		}	
		}	
	}	

